pragma Ada_95;
pragma Warnings (Off);
pragma Source_File_Name (ada_main, Spec_File_Name => "b__uio2_demo.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b__uio2_demo.adb");
pragma Suppress (Overflow_Check);
with Ada.Exceptions;

package body ada_main is

   E118 : Short_Integer; pragma Import (Ada, E118, "system__os_lib_E");
   E013 : Short_Integer; pragma Import (Ada, E013, "system__soft_links_E");
   E023 : Short_Integer; pragma Import (Ada, E023, "system__exception_table_E");
   E063 : Short_Integer; pragma Import (Ada, E063, "ada__containers_E");
   E069 : Short_Integer; pragma Import (Ada, E069, "ada__io_exceptions_E");
   E156 : Short_Integer; pragma Import (Ada, E156, "ada__numerics_E");
   E075 : Short_Integer; pragma Import (Ada, E075, "ada__strings_E");
   E081 : Short_Integer; pragma Import (Ada, E081, "ada__strings__maps_E");
   E147 : Short_Integer; pragma Import (Ada, E147, "ada__strings__maps__constants_E");
   E051 : Short_Integer; pragma Import (Ada, E051, "ada__tags_E");
   E068 : Short_Integer; pragma Import (Ada, E068, "ada__streams_E");
   E116 : Short_Integer; pragma Import (Ada, E116, "interfaces__c_E");
   E186 : Short_Integer; pragma Import (Ada, E186, "interfaces__c__strings_E");
   E025 : Short_Integer; pragma Import (Ada, E025, "system__exceptions_E");
   E121 : Short_Integer; pragma Import (Ada, E121, "system__file_control_block_E");
   E107 : Short_Integer; pragma Import (Ada, E107, "ada__streams__stream_io_E");
   E114 : Short_Integer; pragma Import (Ada, E114, "system__file_io_E");
   E071 : Short_Integer; pragma Import (Ada, E071, "system__finalization_root_E");
   E066 : Short_Integer; pragma Import (Ada, E066, "ada__finalization_E");
   E099 : Short_Integer; pragma Import (Ada, E099, "system__storage_pools_E");
   E093 : Short_Integer; pragma Import (Ada, E093, "system__finalization_masters_E");
   E091 : Short_Integer; pragma Import (Ada, E091, "system__storage_pools__subpools_E");
   E125 : Short_Integer; pragma Import (Ada, E125, "ada__calendar_E");
   E131 : Short_Integer; pragma Import (Ada, E131, "ada__calendar__time_zones_E");
   E017 : Short_Integer; pragma Import (Ada, E017, "system__secondary_stack_E");
   E077 : Short_Integer; pragma Import (Ada, E077, "ada__strings__unbounded_E");
   E144 : Short_Integer; pragma Import (Ada, E144, "ada__directories_E");
   E155 : Short_Integer; pragma Import (Ada, E155, "system__regexp_E");
   E195 : Short_Integer; pragma Import (Ada, E195, "ada__text_io_E");
   E005 : Short_Integer; pragma Import (Ada, E005, "common_E");
   E188 : Short_Integer; pragma Import (Ada, E188, "equal_case_insensitive_E");
   E190 : Short_Integer; pragma Import (Ada, E190, "hash_case_insensitive_E");
   E179 : Short_Integer; pragma Import (Ada, E179, "os_E");
   E165 : Short_Integer; pragma Import (Ada, E165, "strings_E");
   E123 : Short_Integer; pragma Import (Ada, E123, "userio_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "userio__finalize_body");
      begin
         E123 := E123 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "os__finalize_body");
      begin
         E179 := E179 - 1;
         F2;
      end;
      E005 := E005 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "common__finalize_spec");
      begin
         F3;
      end;
      E195 := E195 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "ada__text_io__finalize_spec");
      begin
         F4;
      end;
      E144 := E144 - 1;
      E155 := E155 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "system__regexp__finalize_spec");
      begin
         F5;
      end;
      declare
         procedure F6;
         pragma Import (Ada, F6, "ada__directories__finalize_spec");
      begin
         F6;
      end;
      E077 := E077 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "ada__strings__unbounded__finalize_spec");
      begin
         F7;
      end;
      declare
         procedure F8;
         pragma Import (Ada, F8, "system__file_io__finalize_body");
      begin
         E114 := E114 - 1;
         F8;
      end;
      E093 := E093 - 1;
      E091 := E091 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "system__storage_pools__subpools__finalize_spec");
      begin
         F9;
      end;
      declare
         procedure F10;
         pragma Import (Ada, F10, "system__finalization_masters__finalize_spec");
      begin
         F10;
      end;
      E107 := E107 - 1;
      declare
         procedure F11;
         pragma Import (Ada, F11, "ada__streams__stream_io__finalize_spec");
      begin
         F11;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E023 := E023 + 1;
      Ada.Containers'Elab_Spec;
      E063 := E063 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E069 := E069 + 1;
      Ada.Numerics'Elab_Spec;
      E156 := E156 + 1;
      Ada.Strings'Elab_Spec;
      E075 := E075 + 1;
      Ada.Strings.Maps'Elab_Spec;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E147 := E147 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Streams'Elab_Spec;
      E068 := E068 + 1;
      Interfaces.C'Elab_Spec;
      Interfaces.C.Strings'Elab_Spec;
      System.Exceptions'Elab_Spec;
      E025 := E025 + 1;
      System.File_Control_Block'Elab_Spec;
      E121 := E121 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E107 := E107 + 1;
      System.Finalization_Root'Elab_Spec;
      E071 := E071 + 1;
      Ada.Finalization'Elab_Spec;
      E066 := E066 + 1;
      System.Storage_Pools'Elab_Spec;
      E099 := E099 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Storage_Pools.Subpools'Elab_Spec;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E125 := E125 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E131 := E131 + 1;
      E091 := E091 + 1;
      System.Finalization_Masters'Elab_Body;
      E093 := E093 + 1;
      System.File_Io'Elab_Body;
      E114 := E114 + 1;
      E186 := E186 + 1;
      E116 := E116 + 1;
      Ada.Tags'Elab_Body;
      E051 := E051 + 1;
      E081 := E081 + 1;
      System.Soft_Links'Elab_Body;
      E013 := E013 + 1;
      System.Os_Lib'Elab_Body;
      E118 := E118 + 1;
      System.Secondary_Stack'Elab_Body;
      E017 := E017 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E077 := E077 + 1;
      Ada.Directories'Elab_Spec;
      System.Regexp'Elab_Spec;
      E155 := E155 + 1;
      Ada.Directories'Elab_Body;
      E144 := E144 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E195 := E195 + 1;
      Common'Elab_Spec;
      E005 := E005 + 1;
      E188 := E188 + 1;
      E190 := E190 + 1;
      os'elab_body;
      E179 := E179 + 1;
      E165 := E165 + 1;
      userio'elab_body;
      E123 := E123 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_uio2_demo");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /build/libtexttools-aoODRM/libtexttools-2.1.0/examples/uio2_demo.o
   --   -L/build/libtexttools-aoODRM/libtexttools-2.1.0/examples/
   --   -L/build/libtexttools-aoODRM/libtexttools-2.1.0/examples/
   --   -L/build/libtexttools-aoODRM/libtexttools-2.1.0/build-lib-static/
   --   -L/usr/lib/gcc/x86_64-linux-gnu/6/adalib/
   --   -shared
   --   -lgnat-6
--  END Object file/option list   

end ada_main;
